//
// File name: 3DClass.HPP
//
// Description: Assorted functions and variables
//
// Author: John De Goes
//
// Project: Cutting Edge 3D Game Programming
//

#include <Stdio.h>
#include <String.h>

#ifndef SINCOSHPP
  #define SINCOSHPP
  #include "SinCos.HPP"
#endif

#ifndef POINT2DHPP
  #define POINT2DHPP
  #include "Point2D.HPP"
#endif

#ifndef POINT3DHPP
  #define POINT3DHPP
  #include "Point3D.HPP"
#endif

#ifndef VECTOR3DHPP
  #define VECTOR3DHPP
  #include "Vector3D.HPP"
#endif

#ifndef MATRIX3DHPP
  #define MATRIX3DHPP
  #include "Matrix3D.HPP"
#endif

#ifndef ATYPESHPP
  #define ATYPESHPP
  #include "ATypes.HPP"
#endif

#ifndef PANEL3DHPP
  #define PANEL3DHPP
  #include "Panel3D.HPP"
#endif

#ifndef POLYOBJHPP
  #define POLYOBJHPP
  #include "PolyObj.HPP"
#endif

#define PI 3.141592654

extern long *ZBuffer;
extern long ZTrans;
extern const double MINZ, MAXZ;

void InitMath ();
